3021: Cache packages with bundle package --all
[arvados-dev.git] / jenkins / run-tests.sh
index f5fc1e116356ebcbfd284ea7a4b21b23a46ecd9c..98734ca62dd72f6d2a812bd88af204c5b849104f 100755 (executable)
@@ -21,11 +21,11 @@ Options:
 WORKSPACE=path Arvados source tree to test.
 CONFIGSRC=path Dir with api server config files to copy into source tree.
                (If none given, leave config files alone in source tree.)
-apiserver_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
+services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
                Restrict apiserver tests to the given file
 sdk/python_test="--test-suite test.test_keep_locator"
                Restrict Python SDK tests to the given class
-workbench_test="TEST=test/integration/pipeline_instances_test.rb"
+apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
                Restrict Workbench tests to the given file
 ARVADOS_DEBUG=1
                Print more debug messages
@@ -43,6 +43,26 @@ defaults to $HOME/arvados-api-server if that directory exists.
 More information and background:
 
 https://arvados.org/projects/arvados/wiki/Running_tests
+
+Available tests:
+
+apps/workbench
+apps/workbench_benchmark
+apps/workbench_profile
+doc
+services/api
+services/crunchstat
+services/fuse
+services/keepproxy
+services/keepstore
+services/nodemanager
+sdk/cli
+sdk/python
+sdk/ruby
+sdk/go/arvadosclient
+sdk/go/keepclient
+sdk/go/streamer
+
 EOF
 
 # First make sure to remove any ARVADOS_ variables from the calling
@@ -105,9 +125,62 @@ report_outcomes() {
         done
     fi
 }
+
+sanity_checks() {
+  # Make sure WORKSPACE is set
+  if ! [[ -n "$WORKSPACE" ]]; then
+    echo >&2 "$helpmessage"
+    echo >&2
+    echo >&2 "Error: WORKSPACE environment variable not set"
+    echo >&2
+    exit 1
+  fi
+
+  # Make sure virtualenv is installed
+  `virtualenv --help >/dev/null 2>&1`
+
+  if [[ "$?" != "0" ]]; then
+    echo >&2
+    echo >&2 "Error: virtualenv could not be found"
+    echo >&2
+    exit 1
+  fi
+
+  # Make sure go is installed
+  `go env >/dev/null 2>&1`
+
+  if [[ "$?" != "0" ]]; then
+    echo >&2
+    echo >&2 "Error: go could not be found"
+    echo >&2
+    exit 1
+  fi
+
+  # Make sure gcc is installed
+  `gcc --help >/dev/null 2>&1`
+
+  if [[ "$?" != "0" ]]; then
+    echo >&2
+    echo >&2 "Error: gcc could not be found"
+    echo >&2
+    exit 1
+  fi
+
+}
+
+rotate_logfile() {
+  # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
+  if [[ -f "$1/$2" ]]; then
+    THEDATE=`date +%Y%m%d%H%M%S`
+    mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
+    gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
+  fi
+}
+
 declare -a failures
 declare -A skip
 declare -A testargs
+skip[apps/workbench_profile]=1
 
 while [[ -n "$1" ]]
 do
@@ -123,7 +196,7 @@ do
             skip[$skipwhat]=1
             ;;
         --only)
-            only="$1"; shift
+            only="$1"; skip[$1]=""; shift
             ;;
         --skip-install)
             skip_install=1
@@ -148,14 +221,7 @@ do
     esac
 done
 
-# Sanity check
-if ! [[ -n "$WORKSPACE" ]]; then
-  echo >&2 "$helpmessage"
-  echo >&2
-  echo >&2 "Error: WORKSPACE environment variable not set"
-  echo >&2
-  exit 1
-fi
+sanity_checks
 
 echo "WORKSPACE=$WORKSPACE"
 
@@ -212,21 +278,12 @@ setup_ruby_environment() {
             || fatal 'rvm gemset setup'
 
         rvm env
-
-        # Remove previously installed versions of our own gems. This
-        # ensures the test suites only have access to [a] published
-        # gems and [b] the gems we build and install right now --
-        # never unpublished gems left over from previous builds.
-        gem uninstall --all --executables arvados arvados-cli \
-            || fatal 'clean arvados gems'
     else
-        echo "RVM not found. Will install gems-under-test into \"$GEM_HOME\"."
-
-        # When our "bundle install"s need to install new gems to satisfy
-        # dependencies, we want them to go where "gem install --user-install"
-        # would put them. If rvm is in use (or something else has set
-        # GEM_HOME) we assume "bundle install" already does something
-        # reasonable.
+        # When our "bundle install"s need to install new gems to
+        # satisfy dependencies, we want them to go where "gem install
+        # --user-install" would put them. (However, if the caller has
+        # already set GEM_HOME, we assume that's where dependencies
+        # should be installed, and we should leave it alone.)
 
         if [ -z "$GEM_HOME" ]; then
             user_gempath="$(gem env gempath)"
@@ -240,14 +297,15 @@ setup_ruby_environment() {
         # happen to be installed in $user_gempath, system dirs, etc.
 
         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
-        PATH="${tmpdir_gem_home%%:*}/bin:$PATH"
+        PATH="$tmpdir_gem_home/bin:$PATH"
         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
 
-        echo "Will install dependencies to $GEM_HOME"
+        echo "Will install dependencies to $(gem env gemdir)"
         echo "Will install arvados gems to $tmpdir_gem_home"
         echo "Gem search path is GEM_PATH=$GEM_PATH"
     fi
 }
+
 with_test_gemset() {
     if [[ "$using_rvm" == true ]]; then
         "$@"
@@ -276,7 +334,11 @@ then
 fi
 
 # Needed for run_test_server.py which is used by certain (non-Python) tests.
-pip install PyYAML
+pip install PyYAML || fatal "pip install PyYAML failed"
+
+# Needed for python-daemon 2.0.2, which breaks otherwise with
+# "ImportError: No module named docutils.core"
+pip install docutils || fatal "pip install docutils failed"
 
 checkexit() {
     if [[ "$?" != "0" ]]; then
@@ -302,19 +364,14 @@ do_test() {
         timer_reset
         if [[ "$2" == "go" ]]
         then
-            go test "git.curoverse.com/arvados.git/$1"
+            go test ${testargs[$1]} "git.curoverse.com/arvados.git/$1"
         elif [[ "$2" == "pip" ]]
         then
-           # Other test suites can depend on tests_require
-           # dependencies of this package. For example, keepproxy runs
-           # run_test_server.py, which depends on the yaml package,
-           # which is in sdk/python's tests_require but not
-           # install_requires, and therefore does not get installed by
-           # setuptools until we run "setup.py test" *and* install the
-           # .egg files that setup.py downloads.
            cd "$WORKSPACE/$1" \
-                && python setup.py test ${testargs[$1]} \
-                && (easy_install *.egg || true)
+                && python setup.py test ${testargs[$1]}
+        elif [[ "$2" != "" ]]
+        then
+            "test_$2"
         else
             "test_$1"
         fi
@@ -338,6 +395,9 @@ do_install() {
             cd "$WORKSPACE/$1" \
                 && python setup.py sdist rotate --keep=1 --match .tar.gz \
                 && pip install --upgrade dist/*.tar.gz
+        elif [[ "$2" != "" ]]
+        then
+            "install_$2"
         else
             "install_$1"
         fi
@@ -353,32 +413,36 @@ title () {
     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
 }
 
-install_docs() {
-    cd "$WORKSPACE/doc"
-    bundle install --no-deployment
-    rm -rf .site
-    # Make sure python-epydoc is installed or the next line won't do much good!
-    ARVADOS_API_HOST=qr1hi.arvadosapi.com
-    PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake generate baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
-    unset ARVADOS_API_HOST
+install_doc() {
+    cd "$WORKSPACE/doc" \
+        && (bundle install --local --no-deployment \
+        || bundle install --no-deployment) \
+        && bundle package --all \
+        && rm -rf .site
 }
-do_install docs
+do_install doc
 
 install_ruby_sdk() {
-    cd "$WORKSPACE/sdk/ruby" \
-        && bundle install --no-deployment \
+    with_test_gemset gem uninstall --force --all --executables arvados \
+        && cd "$WORKSPACE/sdk/ruby" \
+        && (bundle install --local --no-deployment \
+        || bundle install --no-deployment) \
+        && bundle package --all \
         && gem build arvados.gemspec \
         && with_test_gemset gem install --no-ri --no-rdoc `ls -t arvados-*.gem|head -n1`
 }
-do_install ruby_sdk
+do_install sdk/ruby ruby_sdk
 
 install_cli() {
-    cd "$WORKSPACE/sdk/cli" \
-        && bundle install --no-deployment \
+    with_test_gemset gem uninstall --force --all --executables arvados-cli \
+        && cd "$WORKSPACE/sdk/cli" \
+        && (bundle install --local --no-deployment \
+        || bundle install --no-deployment) \
+        && bundle package --all \
         && gem build arvados-cli.gemspec \
         && with_test_gemset gem install --no-ri --no-rdoc `ls -t arvados-cli-*.gem|head -n1`
 }
-do_install cli
+do_install sdk/cli cli
 
 # Install the Python SDK early. Various other test suites (like
 # keepproxy) bring up run_test_server.py, which imports the arvados
@@ -397,9 +461,10 @@ do
 done
 
 install_apiserver() {
-    cd "$WORKSPACE/services/api"
-    export RAILS_ENV=test
-    bundle install --no-deployment
+    cd "$WORKSPACE/services/api" \
+        && (RAILS_ENV=test bundle install --local --no-deployment \
+        || RAILS_ENV=test bundle install --no-deployment) \
+        && bundle package --all
 
     rm -f config/environments/test.rb
     cp config/environments/test.rb.example config/environments/test.rb
@@ -438,11 +503,11 @@ install_apiserver() {
     psql arvados_test -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = 'arvados_test';" 2>/dev/null
 
     cd "$WORKSPACE/services/api" \
-        && bundle exec rake db:drop \
-        && bundle exec rake db:create \
-        && bundle exec rake db:setup
+        && RAILS_ENV=test bundle exec rake db:drop \
+        && RAILS_ENV=test bundle exec rake db:setup \
+        && RAILS_ENV=test bundle exec rake db:fixtures:load
 }
-do_install apiserver
+do_install services/api apiserver
 
 declare -a gostuff
 gostuff=(
@@ -458,36 +523,64 @@ do
     do_install "$g" go
 done
 
+install_workbench() {
+    cd "$WORKSPACE/apps/workbench" \
+        && (RAILS_ENV=test bundle install --local --no-deployment \
+        || RAILS_ENV=test bundle install --no-deployment) \
+        && bundle package --all
+}
+do_install apps/workbench workbench
+
+start_api() {
+    echo 'Starting API server...'
+    cd "$WORKSPACE" && \
+        eval $(python sdk/python/tests/run_test_server.py start --auth admin) && \
+        export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" && \
+        export ARVADOS_TEST_API_INSTALLED="$$" && \
+        (env | egrep ^ARVADOS)
+}
+
+stop_api() {
+    unset ARVADOS_TEST_API_HOST
+    cd "$WORKSPACE" && \
+        python sdk/python/tests/run_test_server.py stop
+}
+
 test_doclinkchecker() {
-    cd "$WORKSPACE/doc"
-    bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/
+    (
+        set -e
+        cd "$WORKSPACE/doc"
+        ARVADOS_API_HOST=qr1hi.arvadosapi.com
+        # Make sure python-epydoc is installed or the next line won't
+        # do much good!
+        PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
+    )
 }
-do_test doclinkchecker
+do_test doc doclinkchecker
+
+stop_api
+
+test_apiserver() {
+    cd "$WORKSPACE/services/api"
+    RAILS_ENV=test bundle exec rake test ${testargs[services/api]}
+}
+do_test services/api apiserver
+
+start_api
 
 test_ruby_sdk() {
     cd "$WORKSPACE/sdk/ruby" \
-        && bundle install --no-deployment \
         && bundle exec rake test ${testargs[sdk/ruby]}
 }
-do_test ruby_sdk
+do_test sdk/ruby ruby_sdk
 
 test_cli() {
-    title "Starting SDK CLI tests"
     cd "$WORKSPACE/sdk/cli" \
-        && bundle install --no-deployment \
         && mkdir -p /tmp/keep \
         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test ${testargs[sdk/cli]}
 }
-do_test cli
-
-test_apiserver() {
-    cd "$WORKSPACE/services/api"
-    bundle exec rake test ${testargs[apiserver]}
-}
-do_test apiserver
+do_test sdk/cli cli
 
-# We must test sdk/python before testing services/keepproxy, because
-# keepproxy depends on sdk/python's test dependencies.
 for p in "${pythonstuff[@]}"
 do
     do_test "$p" pip
@@ -500,17 +593,26 @@ done
 
 test_workbench() {
     cd "$WORKSPACE/apps/workbench" \
-        && bundle install --no-deployment \
-        && bundle exec rake test ${testargs[workbench]}
+        && RAILS_ENV=test bundle exec rake test ${testargs[apps/workbench]}
+}
+do_test apps/workbench workbench
+
+test_workbench_benchmark() {
+    cd "$WORKSPACE/apps/workbench" \
+        && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
 }
-do_test workbench
+do_test apps/workbench_benchmark workbench_benchmark
 
-test_workbench_performance() {
+test_workbench_profile() {
     cd "$WORKSPACE/apps/workbench" \
-        && HOME="$GEMHOME" bundle install --no-deployment \
-        && HOME="$GEMHOME" bundle exec rake test:benchmark
+        && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
 }
-do_test workbench_performance
+do_test apps/workbench_profile workbench_profile
+
+rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
+
+stop_api
+rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
 
 report_outcomes
 clear_temp